package net.ase.ingredientapp;

import java.util.ArrayList;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.ImageButton;
import android.widget.Toast;
import android.view.View.OnClickListener;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

/**
 * Esta clase extiende de BaseAdapter. Se utiliza para generar la vista de las preferencias.
 * Itiliza el patrn 'convertView' por motivos de eficiencia.
 * @author Alex
 *
 */
public class AdapterPreferFiltro extends BaseAdapter {
	protected Activity activity;
	protected ArrayList<PreferFiltro> items;
	

	public AdapterPreferFiltro(Activity activity, ArrayList<PreferFiltro> items) {
	    this.activity = activity;
	    this.items = items;
	    
	  }

	@Override
	public int getCount() {
		return items.size();
	}

	@Override
	public Object getItem(int arg0) {
		return items.get(arg0);
	}

	@Override
	public long getItemId(int position) {
		return items.get(position).getId();
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {

		// Generamos una convertView por motivos de eficiencia
		View v = convertView;

		//Asociamos el layout de la lista que hemos creado
		if(convertView == null){
			LayoutInflater inf = (LayoutInflater) activity.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			v = inf.inflate(R.layout.activity_preferencias_item, null);
		}

		// Creamos un objeto filtro
		PreferFiltro filtro = items.get(position);

		//Rellenamos el texto
		TextView cargo = (TextView) v.findViewById(R.id.txtPref);
		cargo.setText(filtro.getTexto());
		
		
		//le ponemos el id en los botones
		ImageButton btnEditPref = (ImageButton) v.findViewById(R.id.btnEditPref);
		btnEditPref.setTag(filtro);
		btnEditPref.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View view) {
				//Toast.makeText(activity,"Hellow this is clicked- EDIT" + ((PreferFiltro) view.getTag()).getTexto(), Toast.LENGTH_LONG).show();

				//Capturamos el id en la base de datos y el texto
				final long prefIdBD=((PreferFiltro) view.getTag()).getId();
				final String txtBD=((PreferFiltro) view.getTag()).getTexto();
				
				AlertDialog.Builder alert = new AlertDialog.Builder(activity);

				alert.setTitle("Preferencia");
				alert.setMessage("Edita el valor y pulsa ok");
				
				// poner el edittext con el valor actual en el alert.
				final EditText input = new EditText(activity);
				input.setText(txtBD);
				alert.setView(input);

				alert.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int whichButton) {
				  
				  // Do something with value!
				  	String aux=input.getText().toString().toUpperCase();
				  	if (aux.length()>0){
				  		((PreferenciasActivity) activity).actualizarPreferencia(prefIdBD,aux );
				  	}
					
				  }
				});

				alert.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int whichButton) {
				    // Cancelado.
				  }
				});

				alert.show();	
				
				
				
				
				
				
				
				
			}
		});

		
		ImageButton btnDelPref = (ImageButton) v.findViewById(R.id.btnDelPref);
		btnDelPref.setTag(filtro);
		btnDelPref.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View view) {
				Toast.makeText(activity,"Preferencia Eliminada"  , Toast.LENGTH_SHORT).show();
				((PreferenciasActivity) activity).eliminarPreferencia(((PreferFiltro) view.getTag()).getId());
			}
		});
		

		// Retornamos la vista
		return v;
	}
}
