package net.ase.ingredientapp;

import java.util.ArrayList;

import android.database.Cursor;

/**
 * Representa un objeto preferencia dentro de la aplicacion.
 * @author Alex
 *
 */
public class PreferFiltro {


	
	protected String texto;
	protected long id;

	public PreferFiltro(String texto) {
		super();
		this.texto = texto;
	}

	public PreferFiltro(String texto, long id) {
		super();
		this.texto = texto;
		this.id = id;
	}

	public String getTexto() {
		return texto;
	}

	public void setTexto(String texto) {
		this.texto = texto;
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	/**
	 * sobreescribimos el mtodo equals para poder comparar elementos 
	 */
	@Override
	public boolean equals(Object o) {
		String strO;
		String strThis;
		boolean res;
		if ((o instanceof PreferFiltro) ) {
			strO=((PreferFiltro) o).getTexto();
			strThis=this.getTexto();
	
			res= strO.equals(strThis);

		} else {
			res= false;
		}
		return res;
	}
	/**
	 * Actuliza un ArrayList de preferencias con los datos del cursor con los filtros.
	 * 
	 * @param c
	 * @return ArrayList<PreferFiltro>
	 */
	public static ArrayList<PreferFiltro> cursorToArrayFiltros(Cursor c,ArrayList<PreferFiltro> arrPref) {
		
		arrPref.clear();
		// Si el cursor contiene datos los aadimos al ArrayList
		if (c.moveToFirst()) {
			do {
				arrPref.add( new PreferFiltro(c.getString(1), c.getInt(0)));
			} while (c.moveToNext());
		}

		return arrPref;
	}

}
