package net.ase.ingredientapp;

import android.app.Activity;
import android.app.ActionBar;
import android.app.Fragment;
import android.database.Cursor;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.os.Build;

/**
 * Esta clase se encarga de mostrar los datos de los productos existentes en la base de datos.
 * @author Alex
 *
 */
public class ProductoEncontradoActivity extends Activity {

	
	//Objetos de la vista
	TextView txtCodigoProdDb;
	TextView txtDescProdDb;
	TextView txtIngreProdDb;
	ImageView imgPrefsFiltros;
	TextView txtPrefsFiltros;
	
	String codigo="";
	
	//clase auxiliar para trabajar con productos
	Producto prod;

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_producto_encontrado);
		
		prod=new Producto(this);
		
		// Referenciar los objetos de la vista
		txtCodigoProdDb = (TextView) findViewById(R.id.txtCodigoProdDb);
		txtDescProdDb = (TextView) findViewById(R.id.txtDescProdDb);
		txtIngreProdDb = (TextView) findViewById(R.id.txtIngreProdDb);
		imgPrefsFiltros = (ImageView) findViewById(R.id.imgPrefsFiltros);
		txtPrefsFiltros  = (TextView) findViewById(R.id.txtPrefsFiltros);
		
        //Recuperamos la informacin pasada en el intent
        Bundle bundle = this.getIntent().getExtras();
        codigo = bundle.getString(AdaptadorBD.PROD_COL_CODIGO);
        cargarDatosDb(codigo);
        		

	}
/**
 * Carga los datos desde la DB y los muestra en la pantalla
 */
private void cargarDatosDb(String codigo){
	Cursor CursorProd;
	Drawable draw;
	CursorProd=prod.productoId(codigo);
	
	
	txtCodigoProdDb.setText(CursorProd.getString(0));
	txtDescProdDb.setText(CursorProd.getString(1));
	txtIngreProdDb.setText(CursorProd.getString(2));
	
	if (prod.cumplePreferencias(CursorProd.getString(2))) {
		//Si cumple las preferencias
		draw=this.getResources().getDrawable(R.drawable.ic_action_ok);
		imgPrefsFiltros.setImageDrawable(draw);
		txtPrefsFiltros.setText(this.getString(R.string.acvty_producto_Enc_Pref_ok));
	}
	else{
		//Si NO CUMPLE las preferencias
		draw=this.getResources().getDrawable(R.drawable.ic_action_ko);
		imgPrefsFiltros.setImageDrawable(draw);
		txtPrefsFiltros.setText(this.getString(R.string.acvty_producto_Enc_Pref_ko));
	}
	
	
}

}
